package org.gcube.application.geoportal.common.model.profile;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;

import javax.json.JsonArray;
import javax.json.JsonObject;

import org.gcube.application.geoportal.common.faults.JsonParseException;
import org.gcube.application.geoportal.common.model.BasicJSONObject;

public class Serialization {

	
	public static <T extends BasicJSONObject> ArrayList<T> asArray(JsonArray array,Class<T> clazz) throws JsonParseException{
		try {
		ArrayList<T> toReturn=new ArrayList<T>();
		if(array!=null)
			for(int i=0;i<array.size();i++)
				toReturn.add(clazz.getConstructor(JsonObject.class).newInstance(array.getJsonObject(i)));
		return toReturn;
		}catch(Exception e) {
			throw new JsonParseException("Unable to create list of "+clazz,e);
		}
	}
	
}