package org.gcube.application.geoportal.common.model;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.json.Json;
import javax.json.JsonObject;

import org.gcube.application.geoportal.common.faults.JsonParseException;
import org.gcube.application.geoportal.common.model.legacy.Concessione;
import org.gcube.application.geoportal.common.model.profile.Profile;
import org.gcube.application.geoportal.common.utils.Files;
import org.junit.Assert;
import org.junit.Test;

import com.fasterxml.jackson.annotation.JsonInclude.Include;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;

public class SerializationTest {

	
	private static ObjectMapper mapper = new ObjectMapper();

	static {
		mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES,false);
		mapper.configure(SerializationFeature.WRITE_EMPTY_JSON_ARRAYS, false);
		mapper.setSerializationInclusion(Include.NON_NULL);
		//		mapper.configure(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS, false);
	}

	
	@Test
	public void readProfile() throws FileNotFoundException, JsonParseException {
		JsonObject object=Json.createReader(new FileInputStream(Files.getFileFromResources("ProfileConcessioni.json"))).readObject();
		
		System.out.println("object is "+object);
		Assert.assertNotNull(object);
		Profile concessione=new Profile(object);
		System.out.println("Profile is "+concessione.toJson());
		
		Assert.assertTrue(concessione.getFields().size()>0);
		
	}
	
	@Test
	public void readConcessione() throws JsonProcessingException, IOException {		
		Concessione concessione=mapper.readerFor(Concessione.class).readValue(
				Files.getFileFromResources("Concessione.json"));
		System.out.println("Concessione is "+concessione.toString());		
		
	}
}
